local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
	login_verify_url = "cls.mg21.youyannet.com/c00/login_verify.php",
	uid = "",
}

--退出
-- function PlatformAdapter:OpenExitDialog()
-- 	agent_helper:Exit(function(result)
-- 		if "true" == result then
-- 			AdapterToLua:endGame()
-- 		end
-- 	end)
-- end

-- 初始化
function AgentAdapter:Init()

	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()

	self:SetChanneId(GLOBAL_CONFIG.package_info.config.plat_id)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return GLOBAL_CONFIG.package_info.config.plat_id
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return self:GetSpid() .. "_" .. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[27]
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "agentres/logo.png"
end


function AgentAdapter:Login(callback)
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登录回调 

end

function AgentAdapter:LoginCallback(result)--登录后回调

	local json_obj = cjson.decode(result)

	local uid = json_obj.uid
	local token = json_obj.token

	local verify_callback = function(url, arg, data, size)
		
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())

		agent_helper:ShowFloatButton()
	end

	self.is_login_verify_ing = true
	
	local real_url = string.format("%s?spid=%s&device=%s&uid=%s&token=%s", self.login_verify_url, self:GetSpid(), tostring(PlatformAdapter.GetPhoneUniqueId()), uid, token)
	
	Log("log_real_url====" .. real_url)

	HttpClient:Request(real_url, "", verify_callback)

	return false
	
end

function AgentAdapter:LogoutCallback(result)--注销回调

	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()--返回到登陆界面
	end
	return true
end


function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买

	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end

	-- double money = jsonObj.getDouble("money");
	-- String goodsName = jsonObj.getString("goodsName");
	-- String orderId = jsonObj.getString("orderId");
	-- String userData = jsonObj.getString("userData");	

	local orderId = server_id .. "_" .. self:GetPlatName() .. "_" .. os.time()
	local param_obj = {}

	param_obj.orderId = orderId   --透传参数，订单号
	param_obj.role_id = role_id     --角色id
	param_obj.role_name = role_name   --角色名字
	param_obj.money = amount      --金额（元）
	param_obj.server_id = server_id   --服务器id
	param_obj.goodsName = "元宝"   --商品名称
	param_obj.description = amount * 10 .. "元宝"   --商品描述
	param_obj.userData = ""

	Log("AgentAdapter:Pay======" .. cjson.encode(param_obj))
	agent_helper:Pay(cjson.encode(param_obj))

end

--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end

function AgentAdapter:SetChanneId(plat_id)
	Log("plat_id====11111===============")
	Log("AgentAdapter:SetChanneId(plat_id)=========" .. plat_id)

	GLOBAL_CONFIG.package_info.config.agent_id = plat_id
	MainProber.agent_id = plat_id
	print("self:GetSpid()=============", self:GetSpid())




end
